; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 1024
WINDOWHEIGHT = 768
width_	= 128;  
height	= 128;  
xrot	equ rot
yrot	equ rot+4
zrot	equ rot+8
xspeed	equ speed
yspeed	equ speed+4
zspeed	equ speed+8
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset title2
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0	
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword
local	rect:RECT; holds coordinates of a rectangle
local	window_width:qword
local	window_height:qword
local	buffer[60h]:byte

        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
	cmp	edx,WM_TIMER
	je	wmTIMER
        cmp	edx,WM_DESTROY
	je      wmDESTROY
        cmp	edx,WM_KEYDOWN
	je      wmKEYDOWN
        cmp	edx,WM_ERASEBKGND
	je	wmERASEBKGND  
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY:invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
        invoke	KillTimer,hWin,10
        invoke	GlobalFree,tex_data
	invoke	RtlExitUserProcess,NULL
;------------------------------
wmERASEBKGND:xor eax,eax
        jmp	wmBYE
wmTIMER:movaps	xmm0,rot
	addps	xmm0,speed
	movaps	rot,xmm0;zrot+=milliseconds*0.015 Increase Rotation On The Z-Axis
;    ?  done  TRUE.   
;        ,    , 
;   .  -    ,  
;  FALSE.
	mov	done,TRUE; Set done To True
	xor	esi,esi;for (int x=0; x<width; x+=2)	; Loop Through All The Rooms
	mov	rdx,tex_data
@@:	xor	edi,edi;for (int y=0; y<height; y+=2); On X And Y Axis
@1:	lea	eax,[rdi+rsi]
	imul	eax,3
	cmp	byte ptr [rdx+rax],0;if (tex_data[((x+(width*y))*3)]==0) if Current Texture Pixel (Room) Is Blank
	jnz	@2
	and	done,FALSE; We Have To Set done To False (Not Finished Yet)
	jmp	@f
@2:	add	edi,2*width_
	cmp	edi,height*width_
	jb	@1
	add	esi,2
	cmp	esi,width_
	jb	@b
@@:	movzx	eax,done
	mov	rdx,title0[rax*8]
	invoke	SetWindowText,hWin
;Check To Make Sure We Are Not Trapped (Nowhere Else To Move)
	mov	rdx,tex_data
	cmp	mx,width_-4
	ja	@f
	mov	eax,my
	shl	eax,7;eax=width*my
	add	eax,mx
	add	eax,2
	imul	eax,3
	cmp	byte ptr [rdx+rax],255; tex_data[(mx+2+width*my)*3]==255
	jnz	@4
@@:     cmp	mx,2;&& ((mx<2 
	jb	@f
	mov	eax,my
	shl	eax,7;eax=width*my
	add	eax,mx
	sub	eax,2
	imul	eax,3
	cmp	byte ptr [rdx+rax],255; tex_data[(mx-2+width*my)*3]==255 
	jnz	@4
@@:     cmp	my,height-4;my>(height-4) 
	ja	@f
	mov	eax,my
	add	eax,2
	shl	eax,7
	add	eax,mx
	imul	eax,3
	cmp	byte ptr [rdx+rax],255; tex_data[(mx+width*(my+2))*3]==255 
	jnz	@4
@@:	cmp	my,2;my<2 
	jb	@f
	mov	eax,my
	sub	eax,2
	shl	eax,7
	add	eax,mx
	imul	eax,3
	cmp	byte ptr [rdx+rax],255; tex_data[(mx+width*(my-2))*3]==255
	jnz	@4
; if we are trapped
@@:	invoke	rand
	and	eax,126
	mov	mx,eax;mx=int(rand()%(width/2))*2 pick a new random X position
	invoke	rand
	and	eax,126
	mov	my,eax;my=int(rand()%(height/2))*2 pick a new random Y position
	shl	eax,7
	add	eax,mx
	imul	eax,3
	mov	rdx,tex_data
        cmp	byte ptr [rdx+rax],0;while tex_data[(mx+width*my)*3]==0 keep picking a random position Until We Find
	jz	@b
; One that has already been tagged (safe starting point)
@4:	invoke	rand;dir=int(rand()%4) pick a random direction
	and	eax,3
	mov	rdx,tex_data
	jmp	handler[rax*8]
dir0: 	cmp	mx,width_-4;if mx<=(width-4) If The Direction Is 0 (Right) And We Are Not At The Far Right
	ja	@5
	mov	eax,my
	shl	eax,7
	add	eax,mx
	add	eax,2
	imul	eax,3
	cmp	byte ptr [rdx+rax],0;if tex_data[(mx+2+width*my)*3]==0	and if The Room To The Right Has Not Already Been Visited
	jnz	@5
	mov	edx,my
	mov	ecx,mx
	inc	ecx
	invoke	UpdateTex;(mx+1,my) update the texture to show path cut out between Rooms
	add	mx,2;mx+=2 move to the right (room to the right)
	jmp	@5
dir1:	cmp	my,height-4;if (my<=(height-4))); If The Direction Is 1 (Down) And We Are Not At The Bottom
	ja	@5
	mov	eax,my
	add	eax,2
	shl	eax,7
	add	eax,mx
	imul	eax,3
	cmp	byte ptr [rdx+rax],0;if tex_data[(mx+width*(my+2))*3]==0 and if The Room Below Has Not Already Been Visited
	jnz	@5
	mov	edx,my
	inc	edx
	mov	ecx,mx
	invoke	UpdateTex;(mx,my+1) Update The Texture To Show Path Cut Out Between Rooms
	add	my,2;my+=2; Move Down (Room Below)
	jmp	@5
dir2:	cmp	mx,2;if (mx>=2) If The Direction Is 2 (Left) And We Are Not At The Far Left
	jb	@5
	mov	eax,my
	shl	eax,7
	add	eax,mx
	sub	eax,2
	imul	eax,3
	cmp	byte ptr [rdx+rax],0;if (tex_data[(((mx-2)+(width*my))*3)]==0)						// And If The Room To The Left Has Not Already Been Visited
	jnz	@5
	mov	edx,my
	mov	ecx,mx
	dec	ecx
	invoke	UpdateTex;(mx-1,my) update the Texture To Show Path Cut Out Between Rooms
	sub	mx,2;mx-=2 Move To The Left (Room To The Left)
        jmp	@5
dir3:	cmp	my,2;if my>=2 if the direction Is 3 (Up) And We Are Not At The Top
	jb	@5
	mov	eax,my
	sub	eax,2
	shl	eax,7
	add	eax,mx
	imul	eax,3
	cmp	byte ptr [rdx+rax],0;if tex_data[(mx+width*(my-2))*3]==0 and If The Room Above Has Not Already Been Visited
	jnz	@5
	mov	edx,my
	dec	edx
	mov	ecx,mx
	invoke	UpdateTex;(mx,my-1) update The Texture To Show Path Cut Out Between Rooms
	sub	my,2;my-=2 Move Up (Room Above)
@5:	mov	edx,my
	mov	ecx,mx
	invoke	UpdateTex; Update Current Room
	jmp	@0
wmKEYDOWN:mov	al,r8b;wParam
	cmp	al,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	cmp	al,VK_SPACE
	jne	wmBYE
	invoke	Reset	
@0:	invoke	InvalidateRect,hWin,0,0
        jmp	wmBYE
;-----------------------------------------	
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
	invoke	SetTimer,hWin,10,25,0;  #10  25mSec
;-------------------------------------------------------
        invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,width_*height*3
	mov	tex_data,rax
	invoke	Reset;	 Call Reset To Build Our Initial Texture, Etc.
; Start Of User Initialization
	invoke	glTexParameteri,GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP
	invoke	glTexParameteri,GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP
	invoke	glTexParameteri,GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR
	invoke	glTexParameteri,GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR
	xor	edx,edx
	mov	r8d,GL_RGB
	mov	r9d,width_
	mov	[rsp+20h],r9
	mov	[rsp+28h],rdx
	mov	[rsp+30h],r8
	mov	qword ptr [rsp+38h],GL_UNSIGNED_BYTE
	mov	rax,tex_data
	mov	[rsp+40h],rax
	invoke	glTexImage2D,GL_TEXTURE_2D
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glClearColor;0,0,0,0 Black Background
	cvtss2sd xmm0,const1
	invoke	glClearDepth;	 Depth Buffer Setup

	invoke	glDepthFunc,GL_LEQUAL; The Type Of Depth Testing
	invoke	glEnable,GL_DEPTH_TEST; Enable Depth Testing

	invoke	glEnable,GL_COLOR_MATERIAL; Enable Color Material (Allows Us To Tint Textures)

	invoke	glEnable,GL_TEXTURE_2D; Enable Texture Mapping
	invoke	gluNewQuadric; Create A Pointer To The Quadric Object
	mov	quadric,rax
	invoke	gluQuadricNormals,eax,GLU_SMOOTH; Create Smooth Normals 
	invoke	gluQuadricTexture,quadric,GL_TRUE; Create Texture Coords

	invoke	glEnable,GL_LIGHT0;	 Enable Light0 (Default GL Light)
        mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;		   
;    , ..    (  glcall ..     8 )
	movq	xmm3,constd100
	movq	xmm2,constd0_1
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity		;   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke  BeginPaint
; --------------- Display the scene
	lea	edx,rect
	invoke	GetClientRect,hWin; Get Window Dimensions
	mov	eax,rect.right
	sub	eax,rect.left
	shr	eax,1
	mov	window_width,rax; Calculate The Width (Right Side-Left Side)
	mov	eax,rect.bottom
	sub	eax,rect.top
	shr	eax,1
	mov	window_height,rax; Calculate The Height (Bottom-Top)
; Update Our Texture... This Is The Key To The Programs Speed... Much Faster Than Rebuilding The Texture Each Time
	mov	rax,tex_data
	mov	qword ptr [rsp+40h],rax
	mov	qword ptr [rsp+38h],GL_UNSIGNED_BYTE
	mov	qword ptr [rsp+30h],GL_RGB
	mov	qword ptr [rsp+28h],128
	mov	qword ptr [rsp+20h],128
	invoke	glTexSubImage2D,GL_TEXTURE_2D,0,0,0;,width_,height,GL_RGB,GL_UNSIGNED_BYTE,tex_data
	invoke	glClear,GL_COLOR_BUFFER_BIT;		 Clear Screen
loop0:	movzx	ecx,red[0]
	movzx	edx,green[0]
	movzx	r8d,blue[0]
	invoke	glColor3ub;		 Assign Color To Current View
;Loop To Draw Our 4 Views
; If We Are Drawing The First Scene
; Set The Viewport To The Top Left.  It Will Take Up Half The Screen Width And Height
	invoke	glViewport,0,window_height,window_width,window_height;
	invoke	glMatrixMode,GL_PROJECTION; Select The Projection Matrix
	invoke	glLoadIdentity ; Reset The Projection Matrix
; Set Up Ortho Mode To Fit 1/4 The Screen (Size Of A Viewport)
	xorps	xmm3,xmm3
	cvtsi2sd xmm2,window_height
	cvtsi2sd xmm1,window_width
	xorps	xmm0,xmm0
	invoke	gluOrtho2D;,0,window_width,window_height,0;
;Are We Drawing The First Image?  (Original Texture... Ortho)
	invoke	glMatrixMode,GL_MODELVIEW; Select The Modelview Matrix
	invoke	glLoadIdentity; Reset The Modelview Matrix

	invoke	glClear,GL_DEPTH_BUFFER_BIT

	invoke	glBegin,GL_QUADS; Begin Drawing A Single Quad
; We Fill The Entire 1/4 Section With A Single Textured Quad.
	xorps	xmm1,xmm1
	movd	xmm0,const1
	invoke	glTexCoord2f;1, 0; 
	invoke	glVertex2i,window_width, 0;
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0,0
	invoke	glVertex2i,0,0
	movd	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0,1
	invoke	glVertex2i,0,window_height
	movd	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;1,1
	invoke	glVertex2i,window_width, window_height
	invoke	glEnd;		 Done Drawing The Textured Quad	
;----------------------------------------------------------------------
loop1:	movzx	ecx,red[1]
	movzx	edx,green[1]
	movzx	r8d,blue[1]
	invoke	glColor3ub;		 Assign Color To Current View
;If We Are Drawing The Second Scene
; Set The Viewport To The Top Right.  It Will Take Up Half The Screen Width And Height
	invoke	glViewport,window_width,window_height,window_width,window_height;
	invoke	glMatrixMode,GL_PROJECTION; Select The Projection Matrix
	invoke	glLoadIdentity ; Reset The Projection Matrix
; Set Up Perspective Mode To Fit 1/4 The Screen (Size Of A Viewport)
	movq	xmm3,constd500
	movq	xmm2,constd0_1
	cvtsi2sd xmm1,window_width
	cvtsi2sd xmm0,window_height
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective;45, (GLfloat)(width_)/(GLfloat)(height), 0.1, 500

	invoke	glMatrixMode,GL_MODELVIEW; Select The Modelview Matrix
	invoke	glLoadIdentity; Reset The Modelview Matrix

	invoke	glClear,GL_DEPTH_BUFFER_BIT

;Are We Drawing The Second Image?  (3D Texture Mapped Sphere... Perspective)
	movd	xmm2,const_14
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTranslatef;0,0,-14; Move 14 Units Into The Screen

	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	movd	xmm1,const1
	movd	xmm0,xrot
	invoke	glRotatef;xrot,1,0,0; Rotate By xrot On The X-Axis
	xorps	xmm3,xmm3
	movd	xmm2,const1
	xorps	xmm1,xmm1
	movd	xmm0,yrot
	invoke	glRotatef;yrot,0,1,0; Rotate By yrot On The Y-Axis
	movd	xmm3,const1
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movd	xmm0,zrot
	invoke	glRotatef;zrot,0,0,1; Rotate By zrot On The Z-Axis

	invoke	glEnable,GL_LIGHTING;		 Enable Lighting
	movq	xmm1,constd4
	invoke	gluSphere,quadric,,32,32; Draw A Sphere
	invoke	glDisable,GL_LIGHTING;		 Disable Lighting

loop2:	movzx	ecx,red[2]
	movzx	edx,green[2]
	movzx	r8d,blue[2]
	invoke	glColor3ub;		 Assign Color To Current View
;If We Are Drawing The Third Scene
; Set The Viewport To The Bottom Right.  It Will Take Up Half The Screen Width And Height
	invoke	glViewport,window_width,0,window_width,window_height
	invoke	glMatrixMode,GL_PROJECTION; Select The Projection Matrix
	invoke	glLoadIdentity ; Reset The Projection Matrix
; Set Up Perspective Mode To Fit 1/4 The Screen (Size Of A Viewport)
	movq	xmm3,constd500
	movq	xmm2,constd0_1
	cvtsi2sd xmm1,window_width
	cvtsi2sd xmm0,window_height
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective;45,(GLfloat)(width)/(GLfloat)(height),0.1,500 

	invoke	glMatrixMode,GL_MODELVIEW; Select The Modelview Matrix
	invoke	glLoadIdentity; Reset The Modelview Matrix

	invoke	glClear,GL_DEPTH_BUFFER_BIT

	movd	xmm2,const_2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTranslatef;0,0,-2; Move 2 Units Into The Screen
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	movd	xmm1,const1
	movd	xmm0,const_45
	invoke	glRotatef;-45,1,0,0	 Tilt The Quad Below Back 45 Degrees.
	movd	xmm3,const1
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movd	xmm0,zrot
	divss	xmm0,const1_5
	invoke	glRotatef;zrot/1.5,0,0,1	 Rotate By zrot/1.5 On The Z-Axis

	invoke	glBegin,GL_QUADS; Begin Drawing A Single Quad
	movd	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;1, 1; 
	xorps	xmm2,xmm2
	movd	xmm1,const1
	movss	xmm0,xmm1
	invoke	glVertex3f; 1,  1, 0;
	movd	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 1; 
	xorps	xmm2,xmm2
	movd	xmm1,const1
	movd	xmm0,const_1
	invoke	glVertex3f;-1,  1, 0;
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 0; 
	xorps	xmm2,xmm2
	movd	xmm1,const_1
	movss	xmm0,xmm1
	invoke	glVertex3f;-1, -1, 0;
	xorps	xmm1,xmm1
	movd	xmm0,const1
	invoke	glTexCoord2f;1, 0; 
	xorps	xmm2,xmm2
	movd	xmm1,const_1
	movd	xmm0,const1
	invoke	glVertex3f; 1, -1, 0;
	invoke	glEnd;		 Done Drawing The Textured Quad

loop3:	movzx	ecx,red[3]
	movzx	edx,green[3]
	movzx	r8d,blue[3]
	invoke	glColor3ub;		 Assign Color To Current View
;If We Are Drawing The Fourth Scene
; Set The Viewport To The Bottom Left.  It Will Take Up Half The Screen Width And Height
	invoke	glViewport,0, 0,window_width,window_height
	invoke	glMatrixMode,GL_PROJECTION; Select The Projection Matrix
	invoke	glLoadIdentity ; Reset The Projection Matrix
; Set Up Perspective Mode To Fit 1/4 The Screen (Size Of A Viewport)
	movq	xmm3,constd500
	movq	xmm2,constd0_1
	cvtsi2sd xmm1,window_width
	cvtsi2sd xmm0,window_height
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective;45,(GLfloat)(width)/(GLfloat)(height),0.1,500

	invoke	glMatrixMode,GL_MODELVIEW; Select The Modelview Matrix
	invoke	glLoadIdentity; Reset The Modelview Matrix

	invoke	glClear,GL_DEPTH_BUFFER_BIT
;Are We Drawing The Fourth Image?  (3D Texture Mapped Cylinder... Perspective)
	movd	xmm2,const_7
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTranslatef;0,0,-7; Move 7 Units Into The Screen
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	movd	xmm1,const1
	movd	xmm0,xrot
	divss	xmm0,const_2
	invoke	glRotatef;-xrot/2,1,0,0;		 Rotate By -xrot/2 On The X-Axis
	xorps	xmm3,xmm3
	movd	xmm2,const1
	xorps	xmm1,xmm1
	movd	xmm0,yrot
	divss	xmm0,const_2
	invoke	glRotatef;-yrot/2,0,1,0;		 Rotate By -yrot/2 On The Y-Axis
	movd	xmm3,const1
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movd	xmm0,zrot
	divss	xmm0,const_2
	invoke	glRotatef;-zrot/2,0,0,1;		 Rotate By -zrot/2 On The Z-Axis

	invoke	glEnable,GL_LIGHTING;		 Enable Lighting
	movd	xmm2,const_2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTranslatef;0,0,-2; Translate -2 On The Z-Axis (To Rotate Cylinder Around The Center, Not An End)
	movq	xmm3,constd4
	movq	xmm2,constd1_5
	movsd	xmm1,xmm2
	invoke	gluCylinder,quadric,,,,32,16; Draw A Cylinder
	invoke	glDisable,GL_LIGHTING;		 Disable Lighting
;-------------------------------------------------------------------
	invoke  glFlush
;   
        invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke  EndPaint,hWin
wmBYE:	leave
	retn	
handler	dq dir0,dir1,dir2,dir3
WndProc	endp
UpdateTex proc ;dmx:dword, dmy:dword;	 Update Pixel dmx, dmy On The Texture
	shl	edx,7;width*dmy
	add	ecx,edx;ecx=dmx+width*dmy
	imul	ecx,3
	mov	rdx,tex_data
	or	dword ptr [rdx+rcx],0FFFFFFh;,       
	ret
UpdateTex endp
Reset proc; Reset The Maze, Colors, Start Point, Etc
	enter	20h,0
	mov	rdi,tex_data
	mov	ecx,width_*height*3/8;128*128*3/8=6144=1800h
	xor	eax,eax
	rep	stosq; Clear Out The Texture Memory With 0's
	invoke	GetTickCount
	invoke	srand,eax;	 Try To Get More Randomness
; Loop So We Can Assign 4 Random Colors
	invoke	rand
	or	eax,10000000110000001000000010000000b
	mov	dword ptr red,eax; Pick A Random Red Color (Bright)
	invoke	rand
	or	eax,10000000100000001100000010000000b
	mov	dword ptr green,eax; Pick A Random Green Color (Bright)
	invoke	rand
	or	eax,10000000100000001000000010000000b
	mov	dword ptr blue,eax; Pick A Random Blue Color (Bright)
        invoke	rand
	and	eax,00000000011111100000000001111110b
	movzx	ecx,ax;int(rand%(width_/2))*2; Pick A New Random X Position
        mov	mx,ecx
	shr	eax,16
	mov	my,eax;int(rand%(height/2))*2;	 Pick A New Random Y Position
	leave
	ret
Reset endp
;---------------------------------------------------------------------------
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

FileName db "br_Rabbit3.cur",0
title1	db "NeHe lesson#42: Multiple Viewports... Maze Complete!",0
title2	db "NeHe lesson#42: Multiple Viewports... Maze is building...",0
title0	dq title2,title1
red	db 4 dup(?);4    
green	db 4 dup(?);4    
blue	db 4 dup(?);4    
tex_data dq ?;width_*height*3 dup (?); 
mx	dd ? ;   ,    . 
;    (    2 )
my	dd ?
dir	db ?;    , ,   
done	db TRUE
quadric		dq ?; 
;-----------------------------
;float
const1		dd 1.0
const_1		dd -1.0
const1_5	dd 1.5
const_2		dd -2.0
const_7		dd -7.0
const_14	dd -14.0
const_45	dd -45.0
;double
constd0_1	dq 0.1
constd1_5	dq 1.5
constd4		dq 4.0
constd45	dq 45.0
constd100	dq 100.0
constd500	dq 500.0
align 16
rot		dd 0,0,0,0;   
speed		dd 0.5,0.75,0.375,0;	 X Rotation Speed
end